/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef KMFRULEEDITMAC_H
#define KMFRULEEDITMAC_H
#include "kmyfirewallruleeditormac.h"
#include <qvariant.h>
#include <qdialog.h>
#include <qptrlist.h>
#include "../core/iptrule.h"

class IPTRule;
class KMFErrorHandler;
class KMFCheckInput;

class KMFRuleEditMac : public KMyFirewallRuleEditorMac {
	Q_OBJECT

public:
	KMFRuleEditMac( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	~KMFRuleEditMac();

	IPTRule* curr_rule;
	void loadRule( IPTRule* );

public slots:
	void accept();
	void slotHelp();
	void reject();

protected:
	bool event( QEvent* );

private:
	KMFCheckInput *m_check_input;
	KMFErrorHandler *m_err_handler;

signals:
	void sigAddRuleOpt( QString*, QPtrList<QString>* );
	void sigDelRuleOpt( QString * );
	void sigDocumentChanged();
	void sigHideMe();
};

#endif // KMFRULEEDITMAC_H
