/***************************************************************************
                       kmfchainlvitem.h  -  description
                          -------------------
 begin                : Fri Aug 23 2002
 copyright            : (C) 2002 by animal
 email                : animal@shit.orphi.iki
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMFCHAINLVITEM_H
#define KMFCHAINLVITEM_H

#include <klistview.h>
#include <qlistview.h>
#include <qpixmap.h>

/**
  *@author animal
  */
class IPTChain;
class KMFRuleLVItem;
class KMFChainLVItem : public KListViewItem {
public:
	KMFChainLVItem( QListView *parent, IPTChain* chain );
	KMFChainLVItem( QListViewItem *parent, IPTChain* chain );
	KMFChainLVItem( QListView *parent, QListViewItem *after, IPTChain* chain );
	KMFChainLVItem( QListViewItem *parent, QListViewItem *after, IPTChain* chain );
	~KMFChainLVItem();

	void setupView();
	void createSmallChainView();
	void setRuleItemOpen( bool );
	IPTChain* chain();
	KMFRuleLVItem* getFirstRuleItem();
	KMFRuleLVItem* getRuleItemNumber( int );
private:
	IPTChain *m_chain;
	void loadChain( IPTChain *chain );
	void loadIcons();
	void createChainView( QListViewItem *, IPTChain* );

	KMFChainLVItem * i_chain_allrules;
	QPixmap icon_firewall, icon_up, icon_down, icon_del, icon_edit, icon_rule, icon_filter, icon_rename,
	icon_chain, icon_log, icon_accept, icon_drop, icon_cmd, icon_reject, icon_return,
	        icon_target, icon_queue, icon_new, icon_fwd,icon_fwds, icon_feed;
};

#endif
